%global tar_version 2.8b2

Name:           jabref
Version:        2.8
Release:        0.5.b2%{?dist}
Summary:        Graphical frontend to manage BibTeX bibliographical databases
License:        GPLv2+ and BSD
Group:          Applications/Publishing
Url:            http://jabref.sourceforge.net/

BuildArch:      noarch

Source0:        http://downloads.sourceforge.net/%{name}/JabRef-%{tar_version}-src.tar.bz2
Source1:        jabref.desktop
# Adapted from the man page included in the Debian jabref package
Source2:        jabref.1

# Don't package other classes into the jar; don't use manifest
Patch0:  %{name}-2.8b-build_xml.patch
# Regenerate the antlr parser with a more modern version of antlr3
Patch1:  %{name}-2.8b-antlr.patch
# Remove the explicit use of the Windows L&F
Patch2:  %{name}-2.4.2-remove-windows.patch
# Remove all uses of "SPL"
Patch3:  %{name}-2.8b-remove-spl.patch
# Point at Fedora libreoffice
Patch4:  %{name}-2.8b-libreoffice.patch

BuildRequires:  jpackage-utils
BuildRequires:  java-devel
BuildRequires:  ant

BuildRequires:  antlr3-java
BuildRequires:  antlr3-tool
BuildRequires:  antlr-tool
BuildRequires:  apache-commons-logging
BuildRequires:  glazedlists
BuildRequires:  jempbox
BuildRequires:  jgoodies-forms
BuildRequires:  jgoodies-looks
BuildRequires:  jgoodies-looks-demo
BuildRequires:  jpf
BuildRequires:  jpfcodegen
BuildRequires:  libreoffice-core
BuildRequires:  microba
BuildRequires:  pdfbox
BuildRequires:  ritopt
BuildRequires:  spin
BuildRequires:  stringtemplate


Requires:       java
Requires:       jpackage-utils

Requires:       antlr3-java
Requires:       antlr3-tool
Requires:       antlr-tool
Requires:       apache-commons-logging
Requires:       glazedlists
Requires:       jempbox
Requires:       jgoodies-forms
Requires:       jgoodies-looks
Requires:       jgoodies-looks-demo
Requires:       jpf
Requires:       jpfcodegen
Requires:       microba
Requires:       pdfbox
Requires:       ritopt
Requires:       spin

%description
JabRef is a graphical front-end to manage BibTeX databases, the standard
LaTeX bibliography reference format. JabRef is build to be platform
independent (requires Java >= 1.4.2). It merges and extends the
functionalities of BibKeeper (Morten O. Alver) and JBibtexManager (Nizar
Batada).

%prep
%setup -q -n %{name}-%{tar_version}

# Don't do the "unjarlib" task as part of the build, and don't put a
# class-path into the manifest
%patch0 -p1

# Fix errors in the antlr parser
%patch1 -p1

# Remove bundled packages and clean up the source
rm -rf src/java/com src/java/gnu
%patch2 -p1

# Remove "sciplore" client
rm -rf src/java/net/sf/jabref/spl src/java/spl
%patch3 -p1

# Fix one file permission
chmod a-x src/txt/gpl2.txt

# Remove all pre-built jar files
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

# Set things up for the OpenOffice plugin
# Use the correct default directories
# %patch4 -p1
# %{__sed} -i 's|LIBDIR|%{_libdir}|' src/java/net/sf/jabref/oo/OpenOfficePanel.java


%build
# Fix errors in the antlr parser and regenerate
rm -f src/java/net/sf/jabref/bst/Bst*.java
mv src/java/net/sf/jabref/bst/bst.g src/java/net/sf/jabref/bst/Bst.g
java -cp `build-classpath antlr antlr3 antlr3-runtime stringtemplate` org.antlr.Tool src/java/net/sf/jabref/bst/Bst.g

# System jars
export CLASSPATH=`build-classpath jgoodies-looks jgoodies-forms spin glazedlists antlr antlr3 antlr3-runtime microba pdfbox ritopt jgoodies-looks-demo jempbox apache-commons-logging jpf jpf-boot jpfcodegen`
# Additional jars from LibreOffice -- build time only
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/juh.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/jurt.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/ridl.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/basis3.4/program/classes/unoil.jar
ant

%install
rm -rf $RPM_BUILD_ROOT
# Install Java stuff
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 build/lib/JabRef-%{tar_version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

# Install desktop file, icon, man page, and shell script
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/
cp -p src/images/JabRef-icon-48.png \
        ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/jabref.png
desktop-file-install \
        --dir=${RPM_BUILD_ROOT}%{_datadir}/applications \
        %{SOURCE1}
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man1
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_mandir}/man1
%jpackage_script net.sf.jabref.JabRefMain "" "" antlr:antlr3:antlr3-runtime:apache-commons-logging:glazedlists:jempbox:jgoodies-forms:jgoodies-looks:jgoodies-looks-demo:jpf:jpf-boot:jpfcodegen-rt:microba:pdfbox:ritopt:spin:jabref jabref true


%post -p /usr/bin/update-desktop-database

%postun -p /usr/bin/update-desktop-database

%files
%doc src/txt/CHANGELOG src/txt/README src/txt/TODO src/txt/*.txt
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_javadir}/%{name}.jar
%{_bindir}/%{name}
%doc %{_mandir}/man1/%{name}.1.gz

%changelog
* Mon Mar 19 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-0.5.b2
- Upgrade to beta 2

* Mon Feb 13 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-0.4.b
- Remove defattr line from files section

* Mon Jan 30 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-0.3.b
- Update after looking at Debian package:
  - Use separately packaged JPFCodeGen library
  - Add man page
  - Add file argument to Exec line in desktop file
- Fix the broken "remove-wsi" patch

* Wed Jan 25 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-0.2.b
- Remove clean section and unnecessary permissions on shell script
- Remove classpath from jar manifest
- Remove unneeded patch

* Wed Jan 25 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-0.1.b
- Initial package
